config/routes.rb
Rails.application.routes.draw do

  # Landing page
  root to: 'site/home#index'

  # Devise routes
  devise_for :users,
    path: '',
    controllers: {
      sessions:      'admin/sessions',
      registrations: 'admin/registrations'
    },
    path_names: {
      sign_in:      '/admin/login',
      password:     '/admin/forgot',
      confirmation: '/admin/confirm',
      unlock:       '/admin/unblock',
      registration: '/admin/register',
      sign_up:      '/admin/new',
      sign_out:     '/admin/logout'
    }

  devise_for :customers,
    path: '',
    controllers: {
      sessions:      'site/sessions',
      registrations: 'site/registrations',
      passwords:     'site/passwords'
    },
    path_names: {
      sign_in:      '/login',
      password:     '/customer/forgot',
      confirmation: '/customer/confirm',
      unlock:       '/customer/unblock',
      registration: 'register',
      sign_up:      '/login',
      sign_out:     '/customer/logout'
    }

  as :user do
    delete 'admin/logout', to: 'admin/sessions#destroy'
  end

  as :customer do
    resource :my_account,     module: 'site', path: 'my-account'

    get    'order-history',   to: 'site/my_accounts#order_history'
    get    'register',        to: 'site/registrations#new'
    get    'login',           to: 'site/sessions#new'
    delete 'customer/logout', to: 'site/sessions#destroy'
  end
  # End Devise routes

  # Site routes
  namespace :site do
    resource :cart_items
    resource :messages
    resources :orders
    resource :product_reviews
    resource :newsletter_subscribers

    # Data retrieval through AJAX.
    scope '/json' do
      post 'filter_skus',  to: 'filter_skus#filter_skus'
      post 'shipping-fee', to: 'checkout#update_shipping'
      post 'retrieve_cities', to: 'cities#retrieve_cities'
    end
  end

  # Paynamics routes.
  scope '/paynamics/notification' do
    post 'sales', to: 'site/paynamics_responses#paynamics_sales_response'
  end

  get 'brands/:slug',         to: 'site/brands#show'
  get 'cart',                 to: 'site/cart#show'
  get 'checkout',             to: 'site/checkout#index'
  get 'checkout/payment',     to: 'site/checkout#payment'
  get 'company-details',      to: 'site/company_details#index'
  get 'contact-us',           to: 'site/contact_us#index'
  get 'faqs',                 to: 'site/faqs#index'
  get 'privacy-policy',       to: 'site/privacy_policy#index'
  get 'search',               to: 'site/search#index'
  get 'shipping',             to: 'site/shipping_details#index'
  get 'shop',                 to: 'site/shop#index'
  get 'shop/:slug',           to: 'site/shop#show'
  get 'terms-and-conditions', to: 'site/terms#index'
  # get 'vpc-checkout',         to: 'site/checkout#vpc_checkout'
  get 'paynamics-checkout',   to: 'site/checkout#paynamics_checkout'
  get 'verify-paynamics',     to: 'site/payments#paynamics_verification' 
  get 'thank-you',            to: 'site/payments#thank_you'
  
  # Mockup routes
  get 'mockups/cookie-policy', to: 'site/mockups#cookie_policy'
  # End mockup routes

  # End Site routes

  # Admin routes
  namespace :admin do
    # Redirect /admin to the dashboard page.
    root to: redirect('admin/dashboard')

    resources :advertisements
    resources :audittrails
    resources :brands
    resources :careers
    resources :dashboard
    resources :categories
    resources :faqs
    resources :inventories
    resources :messages
    resources :orders
    resources :profile
    resources :products
    resources :roles
    resources :subcategories
    resources :terms
    resources :users
    resources :product_reviews,       path: 'product-reviews' 
    resources :company_details,       path: 'company-details'
    resources :order_statuses,        path: 'order-statuses'
    resources :privacy_policies,      path: 'privacy-policy'
    resources :shipping_rates,        path: 'shipping-rates'
    resources :price_updates,         path: 'price-updates' do
      post 'get_sku_price', on: :collection
    end
    resources :dhl_shipper_accounts, path: 'dhl-shipper-settings'
    resources :dhl_products,         path: 'dhl-products'
    resources :dhl_package_types,    path: 'dhl-package-types'
    resources :sliders do
      post 'update_slider_status', on: :collection
    end
    resources :photos do
      collection do
        get 'load_more_photos'
        get 'refresh_photos_list'
      end
    end

    # Maintenance routes.
    scope '/maintenance' do
      resources :uom_labels, path: 'uom-labels'
      resources :uoms
    end

    # Data retrieval through AJAX.
    scope '/json' do
      post 'retrieve_sub_categories',   to: 'products#retrieve_sub_categories'
      post 'retrieve_order_details',    to: 'orders#retrieve_order_details'
      post 'retrieve_dhl_status',       to: 'dhl#tracking'
    end
    
    scope '/dhl' do
      post 'validate-shipment/:order_request_id', to: 'dhl#validate_shipment'
      post 'book-pickup/:order_request_id',       to: 'dhl#book_pickup'
      post 'modify-pickup/:order_request_id',     to: 'dhl#modify_pickup'
      post 'cancel-pickup/:order_request_id',     to: 'dhl#cancel_pickup'
      get  'label-image/:order_request_id',       to: 'dhl#label_image'
    end

    # DataTable retrieval routes.
    scope '/datatables' do
      post 'retrieve_advertisements',       to: 'advertisements#populate_datatables'
      post 'retrieve_audittrails',          to: 'audittrails#populate_datatables'
      post 'retrieve_brands',               to: 'brands#populate_datatables'
      post 'retrieve_careers',              to: 'careers#populate_datatables'
      post 'retrieve_categories',           to: 'categories#populate_datatables'
      post 'retrieve_faqs',                 to: 'faqs#populate_datatables'
      post 'retrieve_inventories',          to: 'inventories#populate_datatables'
      post 'retrieve_show_inventories',     to: 'inventories#populate_show_datatables'
      post 'retrieve_messages',             to: 'messages#populate_datatables'
      post 'retrieve_orders',               to: 'orders#populate_datatables'
      post 'retrieve_order_statuses',       to: 'order_statuses#populate_datatables'
      post 'retrieve_products',             to: 'products#populate_datatables'
      post 'retrieve_reviews',              to: 'product_reviews#populate_datatables'
      post 'retrieve_product_reviews',      to: 'product_reviews#populate_review_datatables'
      post 'retrieve_roles',                to: 'roles#populate_datatables'
      post 'retrieve_subcategories',        to: 'subcategories#populate_datatables'
      post 'retrieve_uom_labels',           to: 'uom_labels#populate_datatables'
      post 'retrieve_uoms',                 to: 'uoms#populate_datatables'
      post 'retrieve_users',                to: 'users#populate_datatables'
      post 'retreive_price_list',           to: 'price_updates#populate_datatables'
      post 'retreive_price_history',        to: 'price_updates#populate_history_datatables'
      post 'retreive_shipping_rates',       to: 'shipping_rates#populate_datatables'
      post 'retrieve_dhl_products',         to: 'dhl_products#populate_datatables'
      post 'retrieve_dhl_package_types',    to: 'dhl_package_types#populate_datatables'
    end
  end
  # End Admin routes
end

app/models/role.rb
class Role < ApplicationRecord

  scope :active_roles,->{
    select("id,name")
      .where("status=1")
      .where("id!=1")
      .order("name")
  }

  scope :for_datatables, -> {
    select("id,name,status")
      .where("id!=1")
      .order("name")
  }

  validates :name, 
    presence: { message: "is required." }, 
    uniqueness: { 
      case_sensitive: false, 
      message: "<b>%{value}</b> has already been taken." }
end

app/controllers/admin/roles_controller.rb
module Admin
  class RolesController < AdminController

    before_action :check_if_has_super_admin_access?
    before_action :set_role, only: [:edit, :update, :destroy]

    # GET /admin/roles
    def index
      @roles = Role.for_datatables
    end

    # GET /admin/roles/new
    def new
      @role = Role.new
    end

    # POST /admin/roles
    def create
      @role = Role.new(role_params)

      respond_to do |format|
        if @role.save
          log_to_audittrail('add', 'ROLE', @role.name)

          format.html {
            redirect_to admin_roles_path, notice: "Role <strong>" + @role.name + "</strong> has been successfully added."
          }
        else
          format.html { render :new }
        end
      end
    end

    # GET /admin/roles/:id/edit
    def edit
    end

    # PATCH /admin/roles/:id
    # PUT /admin/roles/:id
    def update
      respond_to do |format|
        if @role.update(role_params)
          log_to_audittrail('edit', 'ROLE', @role.name)

          format.html {
            redirect_to admin_roles_path, notice: "ROLE <strong>" + @role.name + "</strong> has been successfully updated."
          }
        else
          format.html { render :edit }
        end
      end
    end

    # DELETE /admin/roles/:id
    def destroy
      @role.destroy

      respond_to do |format|
        flash[:notice] = "ROLE <strong>" + @role.name + "</strong> has been successfully removed."
        log_to_audittrail('delete', 'ROLE', @role.name)

        flash.discard if Role.for_datatables.count(1) == 0

        format.html { redirect_to admin_roles_path }
      end
    end

    # POST /admin/datatables/retrieve_roles
    def populate_datatables
      @roles = build_datatable(Role.for_datatables)

      # Return the data being expected by the client.
      respond_to do |format|
        format.json  { @roles }
      end
    end

    private
      def role_params
        params.require(:role).permit(:name, :status)
      end

      def check_if_has_super_admin_access?
        redirect_to admin_dashboard_index_path, error: "You don't have enough permission to access <strong>#{params[:controller]}</strong>." and return unless current_user.is_super_admin?
      end

      def set_role
        @role = Role.find(params[:id])
      end
  end
end

app/views/admin/roles/_content.html.slim
.content
  .notice-container
    -if notice.present?
      .alert.alert-main.alert-success.alert-newversion
        =notice.html_safe
    -elsif error.present?
      .alert.alert-main.alert-danger.alert-newversion
        =error.html_safe
  .row.content-header
    .col-lg-12.col-md-12.col-sm-12.col-xs-12
      h1 Roles
      =link_to new_admin_role_path, id: "add-role", class: "btn btn-success pull-right new no-outline" do
        i.an.an-plus-thin
        | New Role
    .col-lg-12.col-md-12.col-sm-12.col-xs-12
      p.explanation
        | You can perform all role-related maintenance on this module.
    .col-lg-12.col-md-12.col-sm-12.col-xs-12.filter-area
      .search-input-wrapper
        i.an.an-search
        input.search-input.form-control placeholder="Search for Role Name" data-columntosearch="0"
        span.help data-toggle="tooltip" data-placement="top" title="Perform a smart search on Role name."
          i.icon-question-sign &nbsp;
      a.btn.refresh-datatable.pull-right.no-outline href="#" title=""
        i.an.an-repeat-circle-big
        | Refresh
  table#roles-list.table.data-table.display style="table-layout:fixed" 
    thead
      tr
        th.pointer.sortable.font-bold width="60%" 
          | Role
        th.pointer.sortable.font-bold width="25%" 
          | Status
        th.pointer data-column="actions" width="15%"
=render 'delete_modal'

javascript:
  $(document).ready(function() {
    // Variables for Datatables initialization.
    var tableId = "#roles-list",
        ajaxUrl = "/admin/datatables/retrieve_roles",
        defaultOrder = [[0, 'asc']],
        columnDefs = [
          { "name": "name", "data": "name", "className": "truncate", "targets": 0 },
          { "name": "status", 
            "data": "status", 
            "targets": 1,
            "render": function(data) {
              return (data == 0) ? '<span class="label label-danger">Inactive</span>' : '<span class="label label-success">Active</span>';
            }
          },
          { "orderable": false, 
            "className": "actions",
            "data": "id",
            "targets": -1, 
            "render": function(data) {
              return "<ul class='inline-list'>"+
                       "<li data-toggle='tooltip' data-placement='top' title='Edit'>"+
                         "<a class='edit-role no-outline' data-push='true' href='/admin/roles/"+data+"/edit'><i class='an an-pencil-thin-slant'></i></a>"+
                       "</li>"+
                     "</ul>"+
                     "<ul class='inline-list'>"+
                       "<li data-toggle='tooltip' data-placement='top' title='Delete'>"+
                         "<a class='toggle-delete-modal no-outline' data-href='/admin/roles/"+data+"' data-type='role'><i class='an an-trashcan-alt'></i></a>"+
                       "</li>"+
                     "</ul>";
            }
          }
        ];

    generateDatatable(tableId, ajaxUrl, columnDefs, defaultOrder);
  });

app/views/admin/roles/_delete_modal.html.slim
.modal id="role_delete_modal"
  .modal-dialog
    .modal-content
      .modal-header.modal-primary
        button.close aria-hidden="true" data-dismiss="modal" type="button" &times;
        h4.modal-title Delete Role
      .modal-body
        | Are you sure you want to delete the selected Role? (This cannot be undone!)      
      .modal-footer.text-center
        a.btn.btn-danger.confirm.delete-role data-method="delete" rel="nofollow" Yes, delete Role

app/views/admin/roles/_form.html.slim
#active-id.col-lg-10.col-md-10.col-sm-10.col-xs-10.wrapper
  section#roles.content-page.current data-title="Roles"
    .content
      .row.content-header.mb0
        .col-lg-12.col-md-12.col-sm-12.col-xs-12
          h1 =title
        .col-lg-12.col-md-12.col-sm-12.col-xs-12
          p.explanation 
            -if params[:action] == 'new' || params[:action] == 'create'
              | Please complete the form below.
            -else
              | Use the form below to modify the details of 
              strong 
                = @role.name
              |.
      =form_for [:admin, @role] do |f|
        -if @role.errors.any?
          #error-msg-div.alert.alert-danger
            ul
              -@role.errors.full_messages.each do |msg|
                li =msg.html_safe
                
        .form-group
          .btn-toolbar.pull-right.mb0
            a.btn.btn-primary.save.toolbar.submit-summernote href="#"
              | Save
            a.btn.btn-default.cancel.toolbar href="/admin/roles"
              | Cancel
        ul.nav.nav-tabs.post-tab
          li.active
            a target="details" href="#" 
              span.tab-title Details
        #details.tab-content.mb50.mt30
          =render 'role_details',:f=>f

=render '/admin/partials/generic_js'

app/views/admin/roles/_role_details.html.slim
fieldset.form-horizontal.details
  .form-group
    label.control-label.col-lg-2.col-md-2.col-sm-2.col-xs-2 for="status" 
      | Status
      span.help data-toggle="tooltip" data-placement="top" data-container="body" title="Flag if this Role will be available to be assigned to a user. Only active Roles will be available." 
        i.icon-question-sign &nbsp;
    .col-lg-6.col-md-6.col-sm-6.col-xs-6
      =f.check_box :status, :class=>"js-switch"
  .form-group
    label.control-label.col-lg-2.col-md-2.col-sm-2.col-xs-2 for="name" 
      | Name
      span.help data-toggle="tooltip" data-placement="top" data-container="body" title="The name of the Role."  
        i.icon-question-sign &nbsp;
    .col-lg-6.col-md-6.col-sm-6.col-xs-6
      =f.text_field :name, :id=>"name", :class=>"form-control required capitalize", :placeholder=>"Example: Administrator"
      span.error-msg.hidden

app/views/admin/roles/_starter_template.html.slim
.starter-template
  .middle-box
    h1 Roles
    .section-icon
      i.an.an-profile
    p 
      | No Role has been added yet.
    div
      =link_to new_admin_role_path, class: "btn btn-success no-outline" do
        i.an.an-plus-thin
        | Add your first Role

app/views/admin/roles/edit.html.slim
- title "Modify Role"
=render 'form', :title=>"Modify Role"

app/views/admin/roles/index.html.slim
- title "Roles"
.col-lg-10.col-md-10.col-sm-10.col-xs-10.wrapper
  section#roles.content-page.current data-title="Roles"
    -if @roles.present?
      =render 'content'
    -else
      =render 'starter_template'

app/views/admin/roles/new.html.slim
- title "New Role"
=render 'form', :title=>"New Role"